Imports System.Reflection
Imports System.Configuration
Imports System.Web
Imports System.Threading
Imports System.Xml
Imports System.Xml.Xsl
Imports System.Xml.XPath
Imports System
Imports System.Net
Imports System.IO
Imports System.Text
Imports System.Web.Security
Imports str = Microsoft.VisualBasic.Strings

Module Module1
  Dim sVersion As String = ""
  Dim sInputFolder As String = ""
  Dim sInputResourceDictionary As String = ""
  Dim sOutputFolder As String = ""

  Dim sInputFileFull As String = ""
  Dim sOutputFile As String = ""
  Dim sOutputFileFull As String = ""

  Dim oXMLInput As XmlDocument

  Dim oSortedList As SortedList

  Sub Main()
    Dim bParametersOK As Boolean = False

    Try
      sVersion = Assembly.GetExecutingAssembly().GetName().Version().ToString

      Call OutputInfo("ResourceDictionarySorter v" + sVersion, True)
      Call OutputInfo("Sorts XAML Resource Dictionaries alphabetically.", True)
      Call OutputInfo("(c) 2008 - ehuna.org - All Rights Reserved.", True)
      Call OutputInfo("", True)

      bParametersOK = LoadParameters()

      If Not (bParametersOK) Then
        Call OutputInfo("Input parameters not valid.  ResourceDictionarySorter can't continue.", True)
        Call OutputInfo("", True)
        End
      Else
        Call LoadInputXML()
        Call CreateOutputResourceDictionary()
      End If

    Catch ex As Exception
      Call OutputInfo("", True)
      Call OutputInfo("Oops.  An unhandled exception occurred - here are the details:", True)
      Call OutputInfo("", True)
      Call OutputInfo(ex.ToString(), True)
      Call OutputInfo("", True)
      Call OutputInfo("ResourceDictionarySorter can't continue.", True)
      Call OutputInfo("", True)
      End
    End Try

    Call OutputInfo("", True)
    Call OutputInfo("Done.", True)
    Call OutputInfo("", True)
  End Sub
  Sub LoadInputXML()
    Call OutputInfo("Loading " + sInputFileFull + "...", True)
    oXMLInput = New XmlDocument
    oXMLInput.Load(sInputFileFull)
  End Sub
  Sub CreateOutputResourceDictionary()
    Dim Doc As New XmlDocument()
    Dim oXMLResourceDictionary As XmlNode
    Dim oXmlOutput As XmlElement
    Dim i As Integer = 0
    Dim j As Integer = 0

    Dim sType As String = ""
    Dim sKeyName As String = ""
    Dim sOuterXML As String = ""
    Dim oXmlNode As XmlDocument
    Dim oXmlNodeDoc As XmlNode

    Dim oXmlAttribute As XmlAttribute
    Dim bChecking As Boolean = True

    Dim sAttributeName As String = ""
    Dim sAttributeNameExclude As String = ""

    oXmlOutput = Doc.CreateElement("ResourceDictionary")

    ' TODO: I need to add the original attributes
    ' <ResourceDictionary 
    '   xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation" 
    '   xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml" 
    '   xmlns:igEditors="http://infragistics.com/Editors" 
    '   xmlns:Microsoft_Windows_Themes="clr-namespace:Microsoft.Windows.Themes;assembly=PresentationFramework.Aero"
    '   xmlns:d="http://schemas.microsoft.com/expression/blend/2006"
    '   xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
    '   mc:Ignorable="d"
    '   xmlns: Custom = "http://schemas.xceed.com/wpf/xaml/datagrid"
    '>

    Call OutputInfo("  Parsing...", True)
    If oXMLInput.HasChildNodes Then
      If oXMLInput.ChildNodes.Count = 1 Then
        oXMLResourceDictionary = oXMLInput.ChildNodes.Item(0)
        Call OutputInfo("  Found " + oXMLResourceDictionary.ChildNodes.Count.ToString + " child nodes under <ResourceDictionary>.", True)

        For i = 0 To oXMLResourceDictionary.Attributes.Count - 1
          oXmlAttribute = oXMLResourceDictionary.Attributes(i)
          oXmlOutput.Attributes.Append(Doc.ImportNode(oXmlAttribute, True))
        Next

        'oXmlAttribute = Doc.CreateAttribute("xmlns")
        'oXmlAttribute.Value = "http://schemas.microsoft.com/winfx/2006/xaml/presentation"

        oSortedList = New SortedList
        For i = 0 To oXMLResourceDictionary.ChildNodes.Count - 1
          sType = stit(oXMLResourceDictionary.ChildNodes(i).Name)
          sOuterXML = stit(oXMLResourceDictionary.ChildNodes(i).OuterXml)
          sKeyName = GetKeyName(oXMLResourceDictionary.ChildNodes(i))
          If sKeyName <> "" Then
            Call OutputInfo("    Found " + sType + " (" + sKeyName + ")", True)
            'Call OutputInfo("", True)
            'Call OutputInfo("      XML: " + sOuterXML.ToString, True)
            'Call OutputInfo("", True)

            oSortedList.Add(sKeyName, sOuterXML)
          Else
            Call OutputInfo("    -> ERROR: found " + sType + " (blank x:Key)", True)
            'Call OutputInfo("", True)
          End If
        Next

        Call OutputInfo("", True)
        Call OutputInfo("  Sorting...", True)
        Call OutputInfo("", True)

        For Each sKeyName In oSortedList.Keys
          Call OutputInfo("    " + sKeyName, True)

          oXmlNode = New XmlDocument
          oXmlNode.LoadXml(stit(oSortedList(sKeyName)))
          oXmlNodeDoc = Doc.ImportNode(oXmlNode.ChildNodes(0), True)

          bChecking = True
          While bChecking
            bChecking = False

            ' We need to make sure the xmlns attributes are not repeated on every element
            For j = 0 To oXMLResourceDictionary.Attributes.Count - 1
              sAttributeNameExclude = LCase(Trim(stit(oXMLResourceDictionary.Attributes(j).Name)))
              For i = 0 To oXmlNodeDoc.Attributes.Count - 1
                sAttributeName = LCase(Trim(stit(oXmlNodeDoc.Attributes(i).Name)))
                If sAttributeName = sAttributeNameExclude Then
                  oXmlNodeDoc.Attributes.RemoveAt(i)
                  bChecking = True
                  Exit For
                End If
              Next
            Next
          End While

          oXmlOutput.AppendChild(oXmlNodeDoc)
        Next

        sOutputFileFull = sInputFileFull + ".sorted.xaml"
        Call OutputInfo("", True)
        Call OutputInfo("  Saving " + sOutputFileFull, True)
        Call OutputInfo("", True)
        Call SaveTextToFile(oXmlOutput.OuterXml.ToString, sOutputFileFull)
      Else
        Call OutputInfo("Error: found more than one child node in input file (only <ResourceDictionary> is allowed).", True)
      End If

    Else
      Call OutputInfo("Error: no child nodes found in input file.", True)
    End If

  End Sub
  Function GetKeyName(ByVal oXmlNode As XmlNode) As String
    Dim sReturn As String = ""

    Try
      sReturn = Trim(stit(oXmlNode.Attributes.GetNamedItem("x:Key").Value))
    Catch ex As Exception
      sReturn = ""
    End Try

    Return sReturn
  End Function

  Sub OutputInfo(ByVal sInfo As String, ByVal bPrintIt As Boolean)
    If bPrintIt Then Console.WriteLine(sInfo)
  End Sub
  Public Function LoadParameters() As Boolean
    Dim bReturn As Boolean = False

    Try
      sInputFolder = stit(My.Settings.InputFolder)
      sInputResourceDictionary = stit(My.Settings.InputResourceDictionary)
      sOutputFolder = stit(My.Settings.OutputFolder)

      Call OutputInfo("Input Parameters:", True)
      Call OutputInfo("  Input  Resource Dictionary = " + sInputResourceDictionary, True)
      Call OutputInfo("  Input  Folder = " + sInputFolder, True)
      Call OutputInfo("  Output Folder = " + sOutputFolder, True)
      Call OutputInfo("", True)

      sInputFileFull = AddTrailingSlash(sInputFolder) + sInputResourceDictionary
      If Not (FileExists(sInputFileFull)) Then
        Call OutputInfo("Fatal Error: could not find input Resource Dictionary file.", True)
        Call OutputInfo("", True)
        Return False
      End If

      If Not (Directory.Exists(sOutputFolder)) Then
        Call OutputInfo("Fatal Error: output folder does not exist.", True)
        Call OutputInfo("", True)
        Return False
      End If

      sOutputFile = sInputResourceDictionary + ".sorted.xaml"

      bReturn = True
    Catch ex As Exception
      Call OutputInfo(ex.ToString(), True)
    End Try

    Return bReturn
  End Function
  Function stit(ByVal v As Object) As String
    If v Is Nothing Then
      Return ""
    ElseIf IsDBNull(v) Then
      Return ""
    Else
      Return CStr(v)
    End If
  End Function
  Function intit(ByVal v As Object) As Integer
    If v Is Nothing Then
      Return 0
    ElseIf IsDBNull(v) Then
      Return 0
    Else
      If IsNumeric(v) Then
        Return CInt(v)
      Else
        Return 0
      End If
    End If
  End Function
  Function sngit(ByVal v As Object) As Single
    If v Is Nothing Then
      Return 0
    ElseIf IsDBNull(v) Then
      Return 0
    Else
      If IsNumeric(v) Then
        Return CSng(v)
      Else
        Return 0
      End If
    End If
  End Function
  Function dblit(ByVal v As Object) As Double
    If v Is Nothing Then
      Return 0
    ElseIf IsDBNull(v) Then
      Return 0
    Else
      If IsNumeric(v) Then
        Return CDbl(v)
      Else
        Return 0
      End If
    End If
  End Function
  Public Function GetFileContents(ByVal FullPath As String, _
         Optional ByRef ErrInfo As String = "") As String

    Dim strContents As String
    Dim objReader As StreamReader
    Try
      objReader = New StreamReader(FullPath)
      strContents = objReader.ReadToEnd()
      objReader.Close()
      Return strContents
    Catch Ex As System.Exception
      ErrInfo = Ex.Message
      Return ""
    End Try
  End Function
  Function AddTrailingSlash(ByVal sString As String) As String

    If Right(sString, 1) <> "\" Then
      Return sString + "\"
    Else
      Return sString
    End If
  End Function
  Function AddTrailingForwardSlash(ByVal sString As String) As String

    If Right(sString, 1) <> "/" Then
      Return sString + "/"
    Else
      Return sString
    End If
  End Function
  Public Function FileExists(ByVal sFileFullPath As String) As Boolean
    Dim bReturn As Boolean

    Try
      Dim f As New IO.FileInfo(sFileFullPath)
      bReturn = f.Exists
      f = Nothing
    Catch ex As System.Exception
      bReturn = False
    End Try
    Return bReturn
  End Function
  Function ExtractFileName(ByVal sFullPathFileName As String) As String
    Dim i As Integer
    i = InStrRev(sFullPathFileName, "\")
    If i = 0 Then
      Return sFullPathFileName
    Else
      Return Mid(sFullPathFileName, i + 1)
    End If
  End Function
  Public Function GetXMLNodeByXPath(ByVal objXMLDocument As XmlDocument, ByVal sXPath As String) As String
    Dim objNode As System.Xml.XmlNode
    Dim sTemp As String

    Try
      sTemp = ""
      objNode = objXMLDocument.SelectSingleNode(sXPath)
      sTemp = objNode.InnerText
    Catch ex As Exception
      sTemp = ""
    Finally
      objNode = Nothing
    End Try
    Return sTemp
  End Function
  Public Function SaveTextToFile(ByVal strData As String, _
   ByVal FullPath As String, _
     Optional ByVal ErrInfo As String = "") As Boolean

    Dim Contents As String
    Dim bAns As Boolean = False
    Dim objReader As StreamWriter
    Try
      objReader = New StreamWriter(FullPath)
      objReader.Write(strData)
      objReader.Close()
      bAns = True
    Catch Ex As System.Exception
      ErrInfo = Ex.Message
    End Try

    Return bAns
  End Function
End Module
